#include <iostream>
#include <string>
#include <libmemcached/memcached.h>
using namespace std;

#define TARGET_HOST  ""
#define USERNAME ""
#define PASSWORD ""

int main(int argc, char *argv[])
{
    memcached_st *memc = NULL;
    memcached_return rc;
    memcached_server_st *server;
    memc = memcached_create(NULL);
    server = memcached_server_list_append(NULL, TARGET_HOST, 11211,&rc);

    /* SASL */
    sasl_client_init(NULL);
    rc = memcached_set_sasl_auth_data(memc, USERNAME, PASSWORD);
    if(rc != MEMCACHED_SUCCESS) {
        cout<<"Set SASL err:"<< endl;
    }
    rc = memcached_behavior_set(memc,MEMCACHED_BEHAVIOR_BINARY_PROTOCOL,1);
    if(rc != MEMCACHED_SUCCESS) {
        cout<<"Binary Set err:"<<endl;
    }
    /* SASL */

    rc = memcached_server_push(memc,server);
    if(rc != MEMCACHED_SUCCESS) {
      cout <<"Connect Mem err:"<< rc << endl;
    }
    memcached_server_list_free(server);

    string key = "TestKey";
    string value = "TestValue";
    size_t value_length = value.length();
    size_t key_length = key.length();
    int expiration = 0;
    uint32_t flags = 0;

    //Save data
    rc = memcached_set(memc,key.c_str(),key.length(),value.c_str(),value.length(),expiration,flags);
    if (rc != MEMCACHED_SUCCESS){
      cout <<"Save data failed: " << rc << endl;
      return -1;
    }
    cout <<"Save data succeed, key: " << key << " value: " << value << endl;

    cout << "Start get key:" << key << endl;

    char* result = memcached_get(memc,key.c_str(),key_length,&value_length,&flags,&rc);
    cout << "Get value:" << result << endl;

    //Delete data
    cout << "Start delete key:" << key << endl;
    rc = memcached_delete(memc,key.c_str(),key_length,expiration);
    if (rc != MEMCACHED_SUCCESS) {
      cout << "Delete key failed: " << rc << endl;
    }
    cout << "Delete key succeed: " << rc << endl;
    //free
    memcached_free(memc);
    return 0;
}
